/*
 * Created on Apr 18, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package UI;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

import java.awt.Dimension;
import java.lang.reflect.InvocationTargetException;



import Utils.ClusterAlgo;
import Utils.ClusterProgresCB;

/**
 * @author Lior Berry
 * UBC
*/

public class ClusterDialog extends JDialog
				   implements ActionListener
{

	private static String OK_BTN = "OK_BTN";
	private static String CANCEL_BTN = "CANCEL_BTN";
	
	private boolean mComplete = false;
	
	private ClusterAlgo mClusterAlgo = null;
	private JProgressBar mProgBar = null;
	private JComboBox	 mAlgoTypeCB = null;
	
	
	class ClusterWorker extends Thread implements ClusterProgresCB 
	{
		
		public ClusterDialog mDlg;
		
		public void run() {
			DoClustering();
			mDlg.mComplete = true;
			mDlg.setVisible(false);
		}	
		
		protected void 	DoClustering()
		{
				mClusterAlgo.SetCallBack((ClusterProgresCB)this);
				mClusterAlgo.Process();
		}		
		
		protected  void doUpdate(Runnable r) {
			try {
				SwingUtilities.invokeAndWait(r);
			}
			catch (InvocationTargetException e1) {
				System.err.println(e1);
			}
			catch (InterruptedException e2) {
				System.err.println(e2);
			}
		}		
		
		public void ProgressUpdate(int step,int totalNumSteps)
		{
			 final int value = (int)((double)step/(double)(totalNumSteps)* 100.0);

			doUpdate(new Runnable() {
				 public void run() {
					mProgBar.setVisible(true);
					mProgBar.setValue(value);
				 }
			 });

			//mProgBar.setValue(value);
			//mProgBar.repaint();		
		}		
	}

	public ClusterDialog(JFrame ownerFrame,ClusterAlgo inAlgo)
	{
		super(ownerFrame, true);
		this.getContentPane().setLayout(null);
		
		this.setSize(new Dimension(300,200));
		this.setLocationRelativeTo(ownerFrame);
		this.setResizable(false);
                    
		mClusterAlgo = inAlgo;

		this.setTitle("Cluster time series");


		JLabel label = new JLabel("Select clustering type");
		this.getContentPane().add(label);
		label.setLocation(20,20);
		label.setSize(180,20);
		
		mAlgoTypeCB = new JComboBox();
		mAlgoTypeCB.setLocation(20,40);
		mAlgoTypeCB.setSize(150,20);
		mAlgoTypeCB.addItem("RMSD");
		mAlgoTypeCB.addItem("Normalized RMSD");
		mAlgoTypeCB.addItem("Normalized Min/Max RMSD");
		
		this.getContentPane().add(mAlgoTypeCB);

		mProgBar = new JProgressBar();
		mProgBar.setMaximum(100);
		mProgBar.setMinimum(0);
		mProgBar.setValue(0);
		mProgBar.setVisible(false);

		mProgBar.setLocation(20,60);
		mProgBar.setSize(200,20);

		this.getContentPane().add(mProgBar);

		JButton okButton = new JButton("OK");
		okButton.setSize(new Dimension(80,20));
		okButton.setLocation(20,120);
		okButton.setActionCommand(OK_BTN);
		okButton.addActionListener(this);

		this.getContentPane().add(okButton);
		
		JButton cancelButton = new JButton("CANCEL");
		cancelButton.setSize(new Dimension(80,20));
		cancelButton.setLocation(150,120);
		cancelButton.setActionCommand(CANCEL_BTN);
		cancelButton.addActionListener(this);

		this.getContentPane().add(cancelButton);
	}
	
	public boolean GetWasCancelled()
	{
		return !mComplete;
	}
	
	public void actionPerformed(ActionEvent e) {
		String actionCmd = e.getActionCommand();
		
		if (actionCmd == CANCEL_BTN){
			mComplete = false;
			this.setVisible(false);
		}

		if (actionCmd == OK_BTN){
			
			// Set the algorithm type
			
			int algoType = mAlgoTypeCB.getSelectedIndex();
			mClusterAlgo.SetAlgoType(algoType);
			
			// Start the clustering thread
			ClusterWorker cw = new ClusterWorker();
			cw.mDlg = this;
			cw.start();
		}
	}

}
