/*
 * Created on Apr 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package UI;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.ClassLoader;


/**
 * @author Lior Berry
 * UBC
*/
public class FlagComboBox extends JComboBox{

	private ImageIcon[] images;
	private String[] flagStrings = {"CHF", "CAD", "GBP", "JPY", "DEM", "ERO" , "SEK", "ILS" , "HKD",  "KRW",};
	private int mID;

	/** Returns an ImageIcon, or null if the path was invalid. */

	public FlagComboBox()
	{
		Integer[] intArray = new Integer[flagStrings.length];
		for (int i = 0; i < flagStrings.length; i++) {
			intArray[i] = new Integer(i);
			this.addItem(new Integer(i));
		}
	}

	protected ImageIcon createImageIcon(String path) {
		
		//System.out.println(path);
		java.net.URL imgURL = FlagComboBox.class.getResource(path);

/*
		ClassLoader cl = FlagComboBox.class.getClassLoader();
		java.net.URL tmpURL  = cl.getResource(path);
*/
/*
		try{
			tmpURL = cl.getResource(path);
		}
		catch(Exception e)
		{
			System.out.println("getResource exception");
		}
*/
//		java.net.URL tmpURL = cl.getResource("CHF.gif");

/*		
		if (imgURL != null){
			System.out.println(imgURL.toString());
		}
		else{
			System.out.println("Cannot get resource");
		}
*/		
		ImageIcon tmp =  new ImageIcon(imgURL); 
		return tmp;
		/*
		java.net.URL imgURL = FlagComboBox.class.getResource(path);
		if (imgURL != null) {
			return new ImageIcon(imgURL);
		} else {
			System.err.println("Couldn't find file: " + path);
				return null;
		}
		*/
	}

	public String GetSelectedCurrency()
	{
		return flagStrings[getSelectedIndex()];
	}
	
	public int GetID()
	{
		return mID;
	}

	public void Init(int id)
	{
		mID = id;
		//Load the pet images and create an array of indexes.
		images = new ImageIcon[flagStrings.length];
		Integer[] intArray = new Integer[flagStrings.length];
		for (int i = 0; i < flagStrings.length; i++) {
			intArray[i] = new Integer(i);
			//images[i] = createImageIcon("./images/" + flagStrings[i] + ".gif");
			images[i] = createImageIcon(flagStrings[i] + ".gif");

			if (images[i] != null) {
				images[i].setDescription(flagStrings[i]);
			}
		}
		
		ComboBoxRenderer renderer= new ComboBoxRenderer();
		renderer.setPreferredSize(new Dimension(60, 20));
		this.setRenderer(renderer);
		this.setMaximumRowCount(10);
		
	}
	
	class ComboBoxRenderer extends JLabel
						   implements ListCellRenderer {
		
		private Font uhOhFont;

		public ComboBoxRenderer() {
			setOpaque(true);
			setHorizontalAlignment(CENTER);
			setVerticalAlignment(CENTER);
		}

		/*
		 * This method finds the image and text corresponding
		 * to the selected value and returns the label, set up
		 * to display the text and image.
		 */
		public Component getListCellRendererComponent(
										   JList list,
										   Object value,
										   int index,
										   boolean isSelected,
										   boolean cellHasFocus) {
			//Get the selected index. (The index param isn't
			//always valid, so just use the value.)
			int selectedIndex = ((Integer)value).intValue();

			if (isSelected) {
				setBackground(list.getSelectionBackground());
				setForeground(list.getSelectionForeground());
			} else {
				setBackground(list.getBackground());
				setForeground(list.getForeground());
			}

			//Set the icon and text.  If icon was null, say so.
			ImageIcon icon = images[selectedIndex];
			String pet = flagStrings[selectedIndex];
			setIcon(icon);
			if (icon != null) {
				setText(pet);
				setFont(list.getFont());
			} else {
				setUhOhText(pet + " (no image available)",
							list.getFont());
			}

			return this;
		}
	
		//Set the font and text when no image was found.
		protected void setUhOhText(String uhOhText, Font normalFont) {
			if (uhOhFont == null) { //lazily create this font
				uhOhFont = normalFont.deriveFont(Font.ITALIC);
			}
			setFont(uhOhFont);
			setText(uhOhText);
		}
	
	
	}
}
