/*
 * Created on Mar 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package UI;

/**
 * @author Lior Berry
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.JColorChooser;

import Viz.*;


public class UIControls extends JPanel implements ItemListener,ActionListener{
	
	private JSlider 			scrollerR 		= null;

	private JCheckBox			currency2CB		= null;
	private JCheckBox			overlay2CB		= null;
	
	private JCheckBox			showStdDevCB		= null;
	private JCheckBox			showMaxMinCB		= null;
	
	private Label				sliderLabel  	= null;
	private FlagComboBox 		mFlagCombo1		= null;
	private FlagComboBox 		mFlagCombo2		= null;
	private VizPanelControl		mVizPanel		= null;
	
	private JToolBar 			mToolBar		= null;
	
	// Color controls
	private JButton 			mColor1			= null;
	private JButton 			mColor2			= null;
	
	// Link button
	private JRadioButton		mLinkButton		= null;
	
	private static String		NAV_TOOL		= "navTool";
	private static String		MARK_TOOL		= "markTool";
	private static String		SHOW_MARK		= "showMark";
	
	private static String		COLOR1_BTN		= "Color1_BTN";
	private static String		COLOR2_BTN		= "Color2_BTN";
	
	private static String		LINK_BTN		= "Link_BTN";

	public void SetVizPanel(VizPanelControl inVizPanel)
	{
		mVizPanel = inVizPanel;
	}

	public void itemStateChanged(ItemEvent evt) {

		// Get the affected item
		//Object item = evt.getItem();
		Object item = evt.getSource();
		
		if (item == mFlagCombo1 || item == mFlagCombo2){		

			FlagComboBox cb = (FlagComboBox)evt.getSource();
	
			if (evt.getStateChange() == ItemEvent.SELECTED) {
				mVizPanel.CurrencySelectionChanged(cb.GetID(),cb.GetSelectedCurrency());
			} else if (evt.getStateChange() == ItemEvent.DESELECTED) {
				// Item is no longer selected
			}
		}
		else if (item == currency2CB)
		{
			boolean isChecked = (evt.getStateChange() == ItemEvent.SELECTED);
			mVizPanel.ShowSecondCurrencyChanged(isChecked);
			//System.out.println("Check box value: "+isChecked);
		}
		else if (item == overlay2CB)
		{
			boolean isChecked = (evt.getStateChange() == ItemEvent.SELECTED);
			mVizPanel.OverlaySecondCurrencyChanged(isChecked);
			//System.out.println("Check box value: "+isChecked);
		}
		else if (item == showStdDevCB)
		{
			boolean isChecked = (evt.getStateChange() == ItemEvent.SELECTED);
			mVizPanel.DisplayStdDevChanged(isChecked);
		}
		
		else if (item == showMaxMinCB)
		{
			boolean isChecked = (evt.getStateChange() == ItemEvent.SELECTED);
			mVizPanel.DisplayMinMaxChanged(isChecked);
		}
		
		
	}
	
	public void actionPerformed( ActionEvent event )
	{
		String cmdString = event.getActionCommand();
		
		if (cmdString == NAV_TOOL){
			mVizPanel.SetMode(VizPanel.NAV_MODE);
		}
		else if (cmdString == MARK_TOOL){
			mVizPanel.SetMode(VizPanel.MARK_MODE);
		}
		else if (cmdString == SHOW_MARK){
			JRadioButton button = (JRadioButton)(event.getSource());
			mVizPanel.ShowMarksChanged(button.isSelected());
		}
		else if (cmdString == COLOR1_BTN){
			Color newColor = JColorChooser.showDialog(this, "Currency 1 Color", mVizPanel.GetColorForSeries(1));
			if (newColor != null){
				mVizPanel.SetColorForSeries(0,newColor) ;
				mColor1.setBackground(newColor);
			}
		}
		else if (cmdString == COLOR2_BTN){
			Color newColor = JColorChooser.showDialog(this, "Currency 2 Color", mVizPanel.GetColorForSeries(1));
			if (newColor != null){
				mVizPanel.SetColorForSeries(1,newColor) ;
				mColor2.setBackground(newColor);
			}
		}
		else if (cmdString == LINK_BTN){
			JRadioButton button = (JRadioButton)(event.getSource());
			mVizPanel.SetIsLinked(button.isSelected());
		}
	}
	
	private void setRowMinHeight(GridBagLayout gbl, int r, int h) {
			int[] hs = gbl.rowHeights;
			if (hs == null) {
				hs = new int[r+1];
			} else if (hs.length < r+1) {
				hs = new int[r+1];
				System.arraycopy(gbl.rowHeights, 0, hs, 0, gbl.rowHeights.length);
			}
			hs[r] = h;
			gbl.rowHeights = hs;
	}
	
	public void CreateGUI()
	{
		
		GridBagLayout gbl = new GridBagLayout();
		this.setLayout(null);

		GridBagConstraints gbc = null;
		
		/*
		gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.VERTICAL;
		*/
		  
		// Set layout on container
		
		/*
		scrollerR = new JSlider( SwingConstants.VERTICAL,
								 0, 255, 0 );
		scrollerR.setBounds( 20, 35, 30, 100 );
		scrollerR.setMajorTickSpacing( 40 );
		scrollerR.setMinorTickSpacing( 10 );
		scrollerR.setPaintTicks( true );
		scrollerR.setPaintLabels( false );
		*/
		/*
		Dimension d = new Dimension(20,200);
		scrollerR.setPreferredSize(d);
*/

/*
		gbc.gridx = 0;
		gbc.gridy = 0;
		//gbc.anchor = GridBagConstraints.NORTH;
		gbc.fill = GridBagConstraints.VERTICAL;
*/
		//this.add( scrollerR,gbc );

		if (gbc != null){
		gbc.gridx = 1;
		gbc.gridy = 0;
		}

		/*
		sliderLabel = new Label("Bin Size: ",Label.LEFT);		
		add(sliderLabel,gbc); 		
		sliderLabel.setBounds( 10, 5, 80, 10 );
		sliderLabel.setFont(new Font("TimesRoman",Font.PLAIN,10));
		*/
		
		if (gbc != null){
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.insets = new Insets(5,5,5,5);
		}

		mFlagCombo1 = new FlagComboBox();
		mFlagCombo1.Init(1);
		mFlagCombo1.setBounds( 20, 10, 100, 30 );
		mFlagCombo1.addItemListener(this);
		add(mFlagCombo1,gbc);
		mFlagCombo1.setSelectedItem(new Integer(1));

		if (gbc != null){

		gbc.gridx = 0;
		gbc.gridy = 2;
		
		}		
		
		mFlagCombo2 = new FlagComboBox();
		mFlagCombo2.Init(2);
		mFlagCombo2.setBounds( 20, 60, 100, 30 );
		mFlagCombo2.addItemListener(this);
		add(mFlagCombo2,gbc);
		mFlagCombo2.setSelectedItem(new Integer(2));

		currency2CB = new JCheckBox("Show",false);
		currency2CB.setBounds( 125, 68, 60, 30 );
		currency2CB.addItemListener(this);
		//add(currency2CB,gbc);

		overlay2CB = new JCheckBox("Overlay",false);
		overlay2CB.setBounds( 125, 92, 60, 30 );
		overlay2CB.addItemListener(this);
		//add(overlay2CB,gbc);

		showStdDevCB = new JCheckBox("Std-Dev",false);
		showStdDevCB.setBounds( 10, 450, 80, 20 );
		showStdDevCB.addItemListener(this);
		//add(showStdDevCB,gbc);
		
		showMaxMinCB = new JCheckBox("Min/Max",false);
		showMaxMinCB.setBounds( 10, 480, 80, 20 );
		showMaxMinCB.addItemListener(this);
		//add(showMaxMinCB,gbc);
		
		mColor1	= new JButton();
		mColor1.setBackground(mVizPanel.GetColorForSeries(0));
		mColor1.setBounds( 5, 28, 8, 8 );
		mColor1.addActionListener(this);
		mColor1.setActionCommand(COLOR1_BTN);
		add(mColor1,gbc);
		
		mColor2	= new JButton();
		mColor2.setBounds(  5, 68, 8, 8 );
		mColor2.setBackground(mVizPanel.GetColorForSeries(1));	
		mColor2.addActionListener(this);
		mColor2.setActionCommand(COLOR2_BTN);
		add(mColor2,gbc);
		
		mLinkButton = createToolbarButton(
											"linked",
											"link panels",	
											LINK_BTN,
											 "link panels"		
		);
		
		mLinkButton.setSelected(false);
		mLinkButton.setBounds(5,250,24,24);
		add(mLinkButton,gbc);
	}
	
	public void SetBinSizeSlider(int binSize)
	{
		//scrollerR.setValue(binSize);
		Integer aux = new Integer(binSize);
		//sliderLabel.setText("Bin Size: " + aux.toString());
	}
	
	private JRadioButton createToolbarButton( String imgName,
										 String buttonText,
										 String commandStr,
										 String tooltip )
	{
			JRadioButton b;
			b = new JRadioButton();

			java.net.URL imageURL = UIControls.class.getResource(imgName + ".gif");
			java.net.URL disabledImageURL = UIControls.class.getResource(imgName + "_disabled" + ".gif");
			if (imageURL != null && disabledImageURL != null){
				b.setSelectedIcon(new ImageIcon(imageURL));	
				b.setIcon(new ImageIcon(disabledImageURL));
			}
			else{
				b.setText(buttonText);
			}

			// Add optional tooltip help
			if( tooltip != null )
				b.setToolTipText( tooltip );

			// Make sure this button sends a message when the user clicks it
			b.setActionCommand( commandStr );
			b.addActionListener( this );

			return b;
	}
	
	private void addButtons(JToolBar tbar)
	{
		ButtonGroup toolGroup = new ButtonGroup();
		JRadioButton button = null;
		
		button = createToolbarButton(NAV_TOOL,
												  "navigation tool",	
												  NAV_TOOL,
												  "navigation tool"
													);
		toolGroup.add(button);
		button.setSelected(true);											
		tbar.add(button);
		
		button = createToolbarButton(MARK_TOOL,
												  "marking tool",	
												  MARK_TOOL,
												  "marking tool"
													);
		toolGroup.add(button);											
		tbar.add(button);
		
		button = createToolbarButton(SHOW_MARK,
												"show / hide marks",	
												  SHOW_MARK,
												  "show / hide marks"
									);
									
		button.setSelected(true); // default mode is on
		tbar.add(button);
	}
	
	public JToolBar GetToolBar()
	{
		if (mToolBar == null){
			
			JToolBar tbar = new JToolBar(null,JToolBar.HORIZONTAL);
			tbar.setFloatable(false);
			
			// add buttons
			addButtons(tbar);
			
			mToolBar = tbar;			
		}
		
		return mToolBar;	
	}
	
}
