/*
 * Created on Mar 12, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author Lior Berry
 *
 */

package Viz;
import java.awt.*;
import java.awt.geom.Rectangle2D;
//import java.awt.image.*;
import javax.swing.*;

import sun.awt.RepaintArea;

import java.util.*;

import UI.ClusterDialog;
import Utils.GraphicUtils;
import Utils.ClusterAlgo;

import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.util.*;
import java.text.SimpleDateFormat;
import java.text.NumberFormat;


import DataProcess.*;

public class BinDrawTrapez extends VizPanel implements KeyListener,ActionListener{
	
	// visualization controls
	
	private boolean showSecondSeries 	= false;
	private boolean showMonthTicks 		= true;
	private boolean showBinSize 		= true;
	private boolean showNumBins			= false;
	private boolean superimpose 		= false;
	private boolean showStdDev 			= false;
	private boolean showMaxMin 			= false;
	private boolean showFullToolTip 	= false;
	private boolean showTickLines		= true;
	private boolean showConnectingLines	= true;
	private boolean showMarkup			= true;
	private boolean drawYAxis			= false;
	private boolean drawFullBinInfo		= false;
	private boolean drawClusters		= true;
	private boolean drawValueTicks		= false;
	
	
	private boolean mForceRepaint		= true;
	
	private String 	mCurrency[] 			= {"CAD","JPY"};
	
	final 	int 		topChartY 		= 150;
	final	double		maxBarHeight	= topChartY-5;
	private double 		barHeight 		= maxBarHeight;
	
	private int 		numDaysInBin 		= 30;
	private int 		numBins				= 0;
	
	private int 	binWidth 		= 3;
	private int 	drawBinWidth 	= 3;
	private int 	half_BinWidth 	= drawBinWidth / 2;

	private int 	yLabels = topChartY + 50;
	private int 	xLabels = 0;

	private int		mShiftX = 0;
	private int		mDaysShift = 0; 	
	
	private int 	mLastDrawnInfoBinIndex 	= -1;
	private int		mDrawnBinInfoInterval	= -1;
	
	private Point 	mBinInfoHotSpot;
	private Point 	mMousePos;
	private Point 	mStartDragMousePos;
	private int 	mMouseDragStartBinIndex = -1;
	private int 	mLastMarkBinIndex 		= -1;
	
	private Polygon mBinSizeControlBounds 	= null;
	private boolean mBinSizeControlDragMode = false; 
	
	private Polygon mTimeScaleControlBounds = null;
	private boolean mTimeScaleControlDragMode = false; 
	
	
	Color mCurrencyColor[] = {Color.blue,Color.red};
	
	private int binValuesBinSize[] = {-1,-1};
	private int binValuesCurrencySeriesIndex[] = {-1,-1};
	
	int mTickLabelShift = 0;
	
	
	ClusterAlgo mClusteringUtils = new ClusterAlgo();
	
	private ArrayList binValues1;
	private ArrayList binValues2;
	
	private class BinMarker
	{
		public Rectangle 	mBounds 		= new Rectangle();
		public int			mYCoord 		= -1;	
		public int			mXCoord 		= -1;
		public int			mBinIndex		= -1;
		public BinData		mBinData 		= null;
		public boolean 		mNoDataAvailabe	= false;
	};

	private Vector 	mBinMarkerVec1 		= null;
	private Vector 	mBinMarkerVec2 		= null;
	private Vector	mYearLabelTriggers 	= new Vector();
	
	private int mLeftX,mRightX;
	
	private JPopupMenu	mPopupMenu 			= null;
	private JMenu		mSetNumClustersMenu = null;
	
	static private String SHOW_CURR_2		= "SHOW_CURR_2";
	static private String OVERLAY_CURR_2	= "OVERLAY_CURR_2";
	static private String SHOW_STDDDEV		= "SHOW_STDDDEV";
	static private String SHOW_MINMAX		= "SHOW_MINMAX";
	static private String CONNECT_LINES		= "CONNECT_LINES";
	static private String SHOW_BINSIZE		= "SHOW_BINSIZE";
	static private String SHOW_NUMBINS		= "SHOW_NUMBINS";
	static private String SHOW_TICKS		= "SHOW_TICKS";
	
	static private String SHOW_FULL_INFO	= "SHOW_FULL_INFO";
	
	static private String CLUSTER_BINS		= "CLUSTER_BINS";
	
	static private String clusterSizeCmds[] = {"NUM_CLUSTERS_2",
		   	"NUM_CLUSTERS_3",
		   	"NUM_CLUSTERS_4",
			"NUM_CLUSTERS_5",
			"NUM_CLUSTERS_6",
			"NUM_CLUSTERS_7",
			"NUM_CLUSTERS_8"};
	
	static private String SET_BINSIZE_1		= "SET_BINSIZE_1";
	static private String SET_BINSIZE_7		= "SET_BINSIZE_7";
	static private String SET_BINSIZE_30	= "SET_BINSIZE_30";
	static private String SET_BINSIZE_90	= "SET_BINSIZE_90";
	static private String SET_BINSIZE_365	= "SET_BINSIZE_365";
	
	
	// buffered image to store viz
	private BufferedImage bimg[] = null;
	//{null,null};

	public BinDrawTrapez() 
	{ 
		this.addKeyListener( this );
	}
	
	private JPopupMenu CreatePopupMenu()
	{
		if (mPopupMenu == null){
			mPopupMenu = new JPopupMenu("BinX Menu");
			
			JCheckBoxMenuItem menuItem  = null;
			
			JMenu dataSubMenu = new JMenu("Data");
			
			menuItem = new JCheckBoxMenuItem( "Show Currency 2" );
			menuItem.setActionCommand(SHOW_CURR_2);
			menuItem.addActionListener(this);
			dataSubMenu.add(menuItem);
			
			menuItem = new JCheckBoxMenuItem( "Overlay graphs" );
			menuItem.setActionCommand(OVERLAY_CURR_2);
			menuItem.addActionListener(this);
			dataSubMenu.add(menuItem);
			
			mPopupMenu.add(dataSubMenu);

			JMenu infoSubMenu = new JMenu("Bin Information");

			menuItem = new JCheckBoxMenuItem( "Show Std Dev" );
			menuItem.setActionCommand(SHOW_STDDDEV);
			menuItem.addActionListener(this);
			infoSubMenu.add(menuItem);

			menuItem = new JCheckBoxMenuItem( "Show Min / Max" );
			menuItem.setActionCommand(SHOW_MINMAX);
			menuItem.addActionListener(this);
			infoSubMenu.add(menuItem);

			mPopupMenu.add(infoSubMenu);
	
			JMenu clusterMenu = new JMenu("Cluster bins");

			JMenuItem auxMenuItem = new JMenuItem( "Cluster bins" );
			auxMenuItem.setActionCommand(CLUSTER_BINS);
			auxMenuItem.addActionListener(this);
			clusterMenu.add(auxMenuItem);
			
			mSetNumClustersMenu = new JMenu("Num Clusters");
			//clusterNumMenu.setEnabled(false);
			ButtonGroup clusterSizeGroup = new ButtonGroup();
			for (int i=0;i<clusterSizeCmds.length;i++){
				
				JRadioButtonMenuItem radMenuItem = new JRadioButtonMenuItem(Integer.toString(i+2));
				radMenuItem.setActionCommand(clusterSizeCmds[i]);
				radMenuItem.addActionListener(this);
				
				if (i+2 == mClusteringUtils.GetNumClusters()){
					radMenuItem.setSelected(true);
				}
				
				clusterSizeGroup.add(radMenuItem);
				
				mSetNumClustersMenu.add(radMenuItem);
			}
			
			mSetNumClustersMenu.setEnabled(false);
		
			clusterMenu.add(mSetNumClustersMenu);
	
			mPopupMenu.add(clusterMenu);

			JMenu viewSubMenu = new JMenu("View");

			menuItem = new JCheckBoxMenuItem( "Connect data points" );
			menuItem.setActionCommand(CONNECT_LINES);
			menuItem.setSelected(true);
			menuItem.addActionListener(this);
			viewSubMenu.add(menuItem);

			menuItem = new JCheckBoxMenuItem( "Bin size" );
			menuItem.setSelected(true);
			menuItem.setActionCommand(SHOW_BINSIZE);
			menuItem.addActionListener(this);
			viewSubMenu.add(menuItem);

			menuItem = new JCheckBoxMenuItem( "Number of bins" );
			menuItem.setSelected(false);
			menuItem.setActionCommand(SHOW_NUMBINS);
			menuItem.addActionListener(this);
			viewSubMenu.add(menuItem);
			
			mPopupMenu.add(viewSubMenu);
			
			menuItem = new JCheckBoxMenuItem( "Bin Info" );
			menuItem.setActionCommand(SHOW_FULL_INFO);
			menuItem.addActionListener(this);
			viewSubMenu.add(menuItem);
			mPopupMenu.add(viewSubMenu);
			
			menuItem = new JCheckBoxMenuItem( "Ticks" );
			menuItem.setActionCommand(SHOW_TICKS);
			menuItem.addActionListener(this);
			viewSubMenu.add(menuItem);
			mPopupMenu.add(viewSubMenu);
			

			JMenu sizeSubMenu = new JMenu("Bin Size");

			JMenuItem regMenuItem = new JMenuItem( "1 Day" );
			regMenuItem.setActionCommand(SET_BINSIZE_1);
			regMenuItem.addActionListener(this);
			sizeSubMenu.add(regMenuItem);

			regMenuItem = new JMenuItem( "Week" );
			regMenuItem.setActionCommand(SET_BINSIZE_7);
			regMenuItem.addActionListener(this);
			sizeSubMenu.add(regMenuItem);

			regMenuItem = new JMenuItem( "Month" );
			regMenuItem.setActionCommand(SET_BINSIZE_30);
			regMenuItem.addActionListener(this);
			sizeSubMenu.add(regMenuItem);
			
			regMenuItem = new JMenuItem( "Quarter" );
			regMenuItem.setActionCommand(SET_BINSIZE_90);
			regMenuItem.addActionListener(this);
			sizeSubMenu.add(regMenuItem);

			regMenuItem = new JMenuItem( "Year" );
			regMenuItem.setActionCommand(SET_BINSIZE_365);
			regMenuItem.addActionListener(this);
			sizeSubMenu.add(regMenuItem);

			mPopupMenu.add(sizeSubMenu);
			
			add(mPopupMenu);
		}
		
		return mPopupMenu;
	}
	
	public void actionPerformed(ActionEvent e){
		 JMenuItem source = (JMenuItem)(e.getSource());
		 
		 if (e.getActionCommand() == SHOW_CURR_2){
			JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
			ShowSecondCurrencyChanged(cbItem.isSelected());
		 }
		else if (e.getActionCommand() == OVERLAY_CURR_2){
		   JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
		   OverlaySecondCurrencyChanged(cbItem.isSelected());
		}
		else if (e.getActionCommand() == SHOW_STDDDEV){
		   JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
		   DisplayStdDevChanged(cbItem.isSelected());
		}
		else if (e.getActionCommand() == SHOW_MINMAX){
		   JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
		   DisplayMinMaxChanged(cbItem.isSelected());
		}
		else if (e.getActionCommand() == CONNECT_LINES){
		   JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
		   ConnectLinesChanged(cbItem.isSelected());
		}
		else if (e.getActionCommand() == SHOW_BINSIZE){
		   JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
		   ShowBinSize(cbItem.isSelected());
		}
		else if (e.getActionCommand() == SHOW_NUMBINS){
		   JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
		   showNumBins = (cbItem.isSelected());
		   DoRepaint(false);
		}

		
		else if (e.getActionCommand() == CLUSTER_BINS)
		{
			DoClustering();
		}
		else if (e.getActionCommand() == SHOW_FULL_INFO){
		   JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
		   drawFullBinInfo = cbItem.isSelected();

			if (drawFullBinInfo){
				SetDisplayRegionForBinFullBinInfo();
			}
			else{
				SetDefaultDisplayRegion();
			}
			DoRepaint(false);
		}
		else if (e.getActionCommand() == SHOW_TICKS){
			JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
			drawValueTicks = cbItem.isSelected();
			
			// Adjust the display region
			AdjustDisplayRegion();
			
			// redraw to screen
			DoRepaint(false);
		}
		
		else if (e.getActionCommand() == SET_BINSIZE_1){
			ChangeBinSizeAnim(1);
		}
		else if (e.getActionCommand() == SET_BINSIZE_7){
			ChangeBinSizeAnim(7);
		}
		else if (e.getActionCommand() == SET_BINSIZE_30){
			ChangeBinSizeAnim(30);
		}
		else if (e.getActionCommand() == SET_BINSIZE_90){
			ChangeBinSizeAnim(90);
		}
		else if (e.getActionCommand() == SET_BINSIZE_365){
			ChangeBinSizeAnim(365);
		}
		else{
			for (int i=0;i<clusterSizeCmds.length;i++){
				if (e.getActionCommand() == clusterSizeCmds[i]){
					ChangeNumClusters(i+2);
				}
			}
		}
	}
	
	private BufferedImage GetFinalBufferedImage()
	{
		BufferedImage ret = null;
		for (int i=bimg.length-1;i>=0;i--){
			if (bimg[i] != null){
				ret = bimg[i];
				break;
			}
		}
		
		return ret;
	}
	
	private ArrayList ComputeBins(int currencyIndex,int binSize)
	{
		ArrayList binValues = null;
		int seriesIndex = mDataSet.GetSeriesIndexByCode(mCurrency[currencyIndex]);
		
		if (currencyIndex == 0){
			binValues = binValues1;
		}
		else{
			binValues = binValues2;
		}
		
		if (binValues == null || binValuesBinSize[currencyIndex] != binSize || binValuesCurrencySeriesIndex[currencyIndex] != seriesIndex){
			binValues = (mDataSet.GetSeriesByIndex(seriesIndex)).ComputeBins(binSize);
			binValuesBinSize[currencyIndex] = binSize;
			binValuesCurrencySeriesIndex[currencyIndex] = seriesIndex;

			// currently only the first currency is being clustered
			if (currencyIndex == 0){
				mClusteringUtils.Reset();


				if (mSetNumClustersMenu != null)		
					mSetNumClustersMenu.setEnabled(false);
				mVizPanelMgr.NotifyOnClusteringStatusChange(this);
			}
			
		}

		return binValues;
	}
	
	private Graphics2D createGraphics2D(int imgIndex,int w, int h) {
		
		Graphics2D g2 = null;
		
		if (bimg == null){
			bimg = new BufferedImage[2];
			bimg[0] = bimg[1] = null;
		}
			
		
		if (bimg[imgIndex] == null || bimg[imgIndex].getWidth() != w || bimg[imgIndex].getHeight() != h) {
			bimg[imgIndex] = (BufferedImage) createImage(w, h);
		} 
		g2 = bimg[imgIndex].createGraphics();
		g2.setBackground(Color.white);
		g2.clearRect(0, 0, w, h);

		/*
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
							RenderingHints.VALUE_ANTIALIAS_ON);
		*/

		return g2;
	}	
	
	private void PaintBufferedImg()
	{
		if (mDataSet == null)
			return;
					
		mShiftX = mDaysShift / numDaysInBin * binWidth;
		
		Dimension d = getSize();
		
		Graphics2D g2 = createGraphics2D(0,d.width, d.height);
		
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				   RenderingHints.VALUE_ANTIALIAS_ON);
	
		boolean drawBorder = true;
		if (drawBorder){
		
			if (mIsActive){
				g2.setColor(Color.black);
			}
			else{
				g2.setColor(Color.lightGray);
			}
			g2.drawRect(mDisplayRegion.x,mDisplayRegion.y,mDisplayRegion.width,mDisplayRegion.height);
			//g2.fillRect(mDisplayRegion.x,mDisplayRegion.y,mDisplayRegion.width,mDisplayRegion.height);
		}

		int x,y;
		int oldX,oldY;
	
		int x2,y2;
		int oldX2, oldY2;
		
		int oldMin,oldMax;
	
		int i;
		int cx = (int)mDisplayRegion.getCenterX();
		int cy = (int)mDisplayRegion.getCenterY();
		
		int seriesIndex1 = mDataSet.GetSeriesIndexByCode(mCurrency[0]);
		int seriesIndex2 = mDataSet.GetSeriesIndexByCode(mCurrency[1]);
		
		boolean drawTicks = false;
		//binValues1 = (mDataSet.GetSeriesByIndex(seriesIndex1)).ComputeBins(numDaysInBin);
		
		binValues1 = ComputeBins(0,numDaysInBin);
		
		binValues2 = null;
		if (showSecondSeries && seriesIndex2 >= 0){
			binValues2 = ComputeBins(1,numDaysInBin);
			//binValues2 = (mDataSet.GetSeriesByIndex(seriesIndex2)).ComputeBins(numDaysInBin);
		}

		int binSize = numDaysInBin;
	
		double t=1.0;
		double lineGap = barHeight+5.0;
		int entryIndex=0;
		numBins = binValues1.size();

		int expectedWidth = numBins * binWidth;
	
		// adjust bar height
		if (showSecondSeries && !superimpose){
			if (topChartY-2*barHeight-5 < 0){
				barHeight = (topChartY-5)/2;		
			}
		}
		else{
			if (barHeight > topChartY){
				barHeight = topChartY;		
			}
		}
		//y = (int)(150.0+300/numDaysInBin);

		y = topChartY;
		x = (int)mDisplayRegion.getCenterX()-expectedWidth/2 + mShiftX;
		mLeftX 	= Math.max(x,(int)mDisplayRegion.getMinX());
		x = (int)mDisplayRegion.getCenterX()+expectedWidth/2 + mShiftX;
		mRightX = Math.min(x,(int)mDisplayRegion.getMaxX());
		
		mBinMarkerVec1 = new Vector();
		mBinMarkerVec2 = new Vector();

		if (showTickLines){
	
			y = topChartY + 5;
			x = (int)mDisplayRegion.getCenterX()-expectedWidth/2; 
			
			int totalNumOfDays = mDataSet.GetNumIntervals();
			int tickLeap = 365;
			
			int numTicks = totalNumOfDays / tickLeap;
			SimpleDateFormat tickLabelFormatter = new SimpleDateFormat("yy");

			Color paleCyan = new Color(168,255,255);
			
			mYearLabelTriggers = new Vector();
			
			Shape oldclip = g2.getClip();
			g2.clip(mDisplayRegion);
			
			Font smallFont = new Font("Serif",Font.PLAIN,12);
			Font saveFont = g2.getFont();
			g2.setFont(smallFont);
			
			for (i=0; i <= totalNumOfDays ; i+= tickLeap ){
				
				double temp = (double)i/(double)numDaysInBin*binWidth;
				
				int centerX = (int)mDisplayRegion.getCenterX();
				x = (int)temp + (int)mDisplayRegion.getCenterX()-expectedWidth/2 + mShiftX;
				
				if (true || (x>=0 && x <= (int)mDisplayRegion.getMaxX())){
					double factor = (i/(double)totalNumOfDays);	
					
					xLabels = (int)(factor*(mDisplayRegion.width-80)+mDisplayRegion.getMinX()+40);
					g2.setColor(paleCyan);
					
					g2.drawLine(x,y,xLabels,yLabels);
					g2.drawLine(x,y,x,y-(int)maxBarHeight);
					
					if (i < totalNumOfDays){
						String label = tickLabelFormatter.format(mDataSet.GetDateByIntervalIndex(i));
						g2.setColor(Color.gray);
						double tempFactor = ((double)(i+182)/(double)totalNumOfDays);

						FontMetrics fm   = g2.getFontMetrics();  // metrics for this object
						Rectangle2D rect = fm.getStringBounds(label, g2); // size of string
						int strWidth = (int)rect.getWidth();
						xLabels = (int)(tempFactor*(mDisplayRegion.width-80)+mDisplayRegion.getMinX()+40)-strWidth/2;
						g2.drawString(label,xLabels,yLabels+10);
						
						Rectangle labelFinalRect = new Rectangle();
						labelFinalRect.setRect(xLabels,yLabels,strWidth,rect.getHeight());
						mYearLabelTriggers.add(labelFinalRect);
						g2.setColor(Color.magenta);
						//g2.drawRect(labelFinalRect.x,labelFinalRect.y,labelFinalRect.width,labelFinalRect.height);
						
					}
				}
	
			}			
			g2.setFont(saveFont);

			g2.setClip(oldclip);
			
			
			if (drawValueTicks){
				
				int numGridTicks = 10;
				int seriesIndex = mDataSet.GetSeriesIndexByCode(mCurrency[0]);
				TimeSeries ts = mDataSet.GetSeriesByIndex(seriesIndex);

				double maxVal = ts.GetMax();
				double minVal = ts.GetMin();

				NumberFormat numFormat = NumberFormat.getInstance();
				numFormat.setMinimumFractionDigits( 3 );
				numFormat.setMaximumFractionDigits( 3 );

				// add info
				g2.setColor(mCurrencyColor[0]);
				int fontSize = 8;
				Font smallFont2 = new Font("Serif",Font.PLAIN,8);
				Font saveFont2 = g2.getFont();
				g2.setFont(smallFont2);

				int locY = 0;
				
				mTickLabelShift = 8;
				
				int maxWidth = 0;
				FontMetrics auxFM   = g2.getFontMetrics();  // metrics for this object
				
				for (int j=0;j<numGridTicks;j++){
					double ratio = (double)j/(double)numGridTicks;
					double val = ratio * (maxVal-minVal) + minVal;
					locY = (int)(y - ratio * barHeight);

					String binValueStr = numFormat.format(val);
					
					Rectangle2D auxRect = auxFM.getStringBounds(binValueStr, g2); // size of string
					if (auxRect.getWidth() > maxWidth){
						maxWidth = (int)auxRect.getWidth();
					}
						
					g2.drawLine(mRightX,locY,mRightX+5,locY);
					g2.drawString(binValueStr,mRightX+5,locY+fontSize/2);
				}
				
				mTickLabelShift += maxWidth;
		
				g2.setFont(saveFont2);
			}
			else{
				mTickLabelShift = 8;
			}
		
		}

		x = (int)mDisplayRegion.getCenterX()-expectedWidth/2 + mShiftX;
		
		oldX = -1;
		oldY = -1;
		
		oldMin = -1;
		oldMax = -1;
				
		Color lightColor = mCurrencyColor[0].brighter();
		
		for (i=0; i < numBins ; i++ ){
			
			if (x>=(int)mDisplayRegion.getMinX() && x <= (int)mDisplayRegion.getMaxX()){
				
				BinData binVals = (BinData)(binValues1.get(i));


				double val = binVals.mNormalizedValue;
				val *= barHeight;
				//g2.drawLine(x,y,x,(int)(y-val));

				if (binVals.mBinValue > 0){

					if (showConnectingLines && oldY >= 0){
						
						g2.setColor(lightColor);
						g2.drawLine(x,y-(int)val,oldX,oldY);
					}
		
					if (drawClusters && binVals.mClusterID >= 0){
						g2.setColor(GraphicUtils.GetColorForCluster(binVals.mClusterID));
						g2.fillRect(x-half_BinWidth,y-(int)val-half_BinWidth-3,drawBinWidth,(int)9);
					}
		
					g2.setColor(mCurrencyColor[0]);
					//g2.fillRect(x,y-(int)val,binWidth,(int)val);
					g2.fillRect(x-half_BinWidth,y-(int)val-half_BinWidth,drawBinWidth,(int)3);
					//g2.drawRect(x-half_BinWidth,y-(int)val-half_BinWidth,binWidth,(int)3);
	
					
					//g2.fillOval(x,y-(int)val,10,10);
					//g2.setColor(Color.cyan);
					//g2.drawRect(x,y-(int)val,binWidth,(int)val);
		
					// draw max and min
					if (showMaxMin){
						if (showConnectingLines && oldMin > 0){

							Color auxColor = GraphicUtils.GetBrighterColor(mCurrencyColor[0],0.2);
							g2.setColor(auxColor);
					
							g2.drawLine(oldX,oldMax,x,(y-(int)(binVals.mMaxValue*barHeight)));
							g2.drawLine(oldX,oldMin,x,(y-(int)(binVals.mMinValue*barHeight)));
						}
						else{
							Color auxColor = GraphicUtils.GetBrighterColor(mCurrencyColor[0],0.2);
							g2.setColor(auxColor);
							int yMax = (y-(int)(binVals.mMaxValue*barHeight));
							int yMin = (y-(int)(binVals.mMinValue*barHeight));
							
							g2.drawLine(x-half_BinWidth,yMax,x+half_BinWidth,yMax);
							g2.drawLine(x-half_BinWidth,yMin,x+half_BinWidth,yMin);
						}

					}			
					// draw marks for standard deviation
					if (showStdDev){
					
						g2.setColor(Color.gray);
						double stdDev = binVals.mStdDev * barHeight;
			
						int topY = (y-(int)(val - binVals.mStdDev*barHeight));
						int bottomY = (y-(int)(val + binVals.mStdDev*barHeight));
						//g2.drawLine(x+1,(y-(int)(binVals.mMaxValue*barHeight)),x+1,(y-(int)(binVals.mMinValue*barHeight)));
						g2.drawLine(x,topY,x,bottomY);
						g2.drawLine(x-half_BinWidth,topY,x+half_BinWidth,topY);
						g2.drawLine(x-half_BinWidth,bottomY,x+half_BinWidth,bottomY);
						
						//g2.drawLine(x,(y-(int)(val - binVals.mStdDev*barHeight)),x,(y-(int)(val + binVals.mStdDev*barHeight)));
					
					}	

					oldX = x;
					oldY = y-(int)val;
					oldMin = (y-(int)(binVals.mMinValue*barHeight));
					oldMax = (y-(int)(binVals.mMaxValue*barHeight));
		
				}
								
				BinMarker marker = new BinMarker();
				marker.mBinIndex = i;
				marker.mBinData = binVals;
				int toleranceBorder = 8;
				marker.mBounds.setRect(x,y-(int)val-toleranceBorder,binWidth,(int)3+2*toleranceBorder);
				marker.mYCoord = y-(int)val;
				marker.mXCoord = x;
				marker.mNoDataAvailabe = (binVals.mBinValue == 0);
				mBinMarkerVec1.add(marker);
				

			}
			
			x+= binWidth;			
		}
		
		if (showSecondSeries && seriesIndex2 >= 0){

			oldX = -1;
			oldY = -1;
			oldMin = -1;
			oldMax = -1;
			
			Color lightRed = mCurrencyColor[1].brighter();
			
			if (!superimpose){
				y = y - (int)(barHeight);
			}
			x = (int)mDisplayRegion.getCenterX()-expectedWidth/2 + mShiftX;
			
			if (drawValueTicks){
				
				int tickLabelShift = 8;
				
				if (superimpose)
					tickLabelShift = mTickLabelShift;
				
				int numGridTicks = 10;
				int seriesIndex = mDataSet.GetSeriesIndexByCode(mCurrency[1]);
				TimeSeries ts = mDataSet.GetSeriesByIndex(seriesIndex);

				double maxVal = ts.GetMax();
				double minVal = ts.GetMin();

				NumberFormat numFormat = NumberFormat.getInstance();
				numFormat.setMinimumFractionDigits( 3 );
				numFormat.setMaximumFractionDigits( 3 );

				// add info
				g2.setColor(mCurrencyColor[1]);
				int fontSize = 8;
				Font smallFont2 = new Font("Serif",Font.PLAIN,8);
				Font saveFont2 = g2.getFont();
				g2.setFont(smallFont2);

				int locY = 0;
				
				int maxWidth = 0;
				FontMetrics auxFM   = g2.getFontMetrics();  // metrics for this object
				
				for (int j=0;j<numGridTicks;j++){
					double ratio = (double)j/(double)numGridTicks;
					double val = ratio * (maxVal-minVal) + minVal;
					locY = (int)(y - ratio * barHeight);

					String binValueStr = numFormat.format(val);
					
					Rectangle2D auxRect = auxFM.getStringBounds(binValueStr, g2); // size of string
					if (auxRect.getWidth() > maxWidth){
						maxWidth = (int)auxRect.getWidth();
					}
						
					if (!superimpose){
						g2.drawLine(mRightX,locY,mRightX+tickLabelShift,locY);
					}
					g2.drawString(binValueStr,mRightX+tickLabelShift,locY+fontSize/2);
				}

				if (superimpose){
					mTickLabelShift += maxWidth;
				}else{
					if (maxWidth > mTickLabelShift)
						mTickLabelShift = maxWidth;
				}

				g2.setFont(saveFont2);
			}
			
			for (i=0; i<numBins; i++ ){

				if (x>=(int)mDisplayRegion.getMinX() && x <= (int)mDisplayRegion.getMaxX()){

					BinData binVals = (BinData)(binValues2.get(i));
	
					double val = binVals.mNormalizedValue;
		
					val *= barHeight;
					//g2.drawLine(x,y,x,(int)(y-val));

					if (binVals.mBinValue > 0){

						if (showConnectingLines && oldY >= 0){
							g2.setColor(lightRed);
							g2.drawLine(x,y-(int)val,oldX,oldY);
						}
	
			
						g2.setColor(mCurrencyColor[1]);
						//g2.fillRect(x,y-(int)val,binWidth,(int)val);
						//g2.fillRect(x,y-(int)val,binWidth,(int)3);
						g2.fillRect(x-half_BinWidth,y-(int)val-half_BinWidth,drawBinWidth,(int)3);
		
						//g2.drawRect(x,y-(int)val,binWidth,(int)val);
						//g2.drawRect(x,y-(int)val,binWidth,(int)5);
		
						// draw max and min
						if (showMaxMin){

							
							if (showConnectingLines && oldMin > 0){
								Color auxColor = GraphicUtils.GetBrighterColor(mCurrencyColor[1],0.2);
								g2.setColor(auxColor);
					
								g2.drawLine(oldX,oldMax,x,(y-(int)(binVals.mMaxValue*barHeight)));
								g2.drawLine(oldX,oldMin,x,(y-(int)(binVals.mMinValue*barHeight)));
							}
							else{							
								Color auxColor = GraphicUtils.GetBrighterColor(mCurrencyColor[1],0.2);
								g2.setColor(auxColor);
								int yMax = (y-(int)(binVals.mMaxValue*barHeight));
								int yMin = (y-(int)(binVals.mMinValue*barHeight));
								
								g2.drawLine(x-half_BinWidth,yMax,x+half_BinWidth,yMax);
								g2.drawLine(x-half_BinWidth,yMin,x+half_BinWidth,yMin);
							}

						}
						
						// draw standard deviation
						if (showStdDev){
							g2.setColor(Color.gray);

							int topY = (y-(int)(val - binVals.mStdDev*barHeight));
							int bottomY = (y-(int)(val + binVals.mStdDev*barHeight));
							//g2.drawLine(x+1,(y-(int)(binVals.mMaxValue*barHeight)),x+1,(y-(int)(binVals.mMinValue*barHeight)));
							g2.drawLine(x,topY,x,bottomY);
							g2.drawLine(x-half_BinWidth,topY,x+half_BinWidth,topY);
							g2.drawLine(x-half_BinWidth,bottomY,x+half_BinWidth,bottomY);
						}

						oldX = x;
						oldY = y-(int)val;
						oldMin = (y-(int)(binVals.mMinValue*barHeight));
						oldMax = (y-(int)(binVals.mMaxValue*barHeight));

					}
					

					BinMarker marker = new BinMarker();
					marker.mBinData = binVals;
					marker.mBinIndex = i;
					int toleranceBorder = 8;
					marker.mBounds.setRect(x,y-(int)val-toleranceBorder,binWidth,(int)3+2*toleranceBorder);
					marker.mYCoord = y-(int)val;
					marker.mXCoord = x;
					marker.mNoDataAvailabe = (binVals.mBinValue == 0);
					mBinMarkerVec2.add(marker);

				}				
				x+= binWidth;	
			}		
		}
		
		// add an extra shift to the tick labels
		mTickLabelShift += 3;
		
		DrawBinHighlight(g2);
		DrawBinSizeMarker(g2);
		DrawTimeScaleMarker(g2);
		DrawYAxis(g2);
		g2.dispose();
		
		DrawBinInfo(null,mDrawnBinInfoInterval,-1,false,false);		
	}

	public void paintComponent(Graphics gfx) {
		
		super.paintComponent(gfx);

		Dimension d = getSize();

		if (bimg == null){
			Graphics2D g = createGraphics2D(0,d.width,d.height);
			g.dispose();
		}

		Graphics2D g = (Graphics2D) gfx;
		BufferedImage fImg = GetFinalBufferedImage();
		if (mForceRepaint || fImg == null || fImg.getWidth() != d.width || fImg.getHeight() != d.height)
		{
			PaintBufferedImg();
			mForceRepaint = false;
		}

		g.drawImage(GetFinalBufferedImage(), 1, 1, this);

	}
	
	public void keyPressed( KeyEvent e ) 
	{
		int key = e.getKeyCode();
		boolean consumed = false;
		boolean isCtrlClicked = ((e.getModifiers() & InputEvent.CTRL_MASK) != 0);


		if (key == KeyEvent.VK_TAB)
		{
			mVizPanelMgr.DeclineActivePanel(this);
			consumed = true;
		}

		if (key == KeyEvent.VK_UP){
			
			if (mMode == NAV_MODE){
				if (numDaysInBin >= 2){
					ChangeBinSize(numDaysInBin-1,true);
					consumed = true;
				}
			}

		}
		else if (key == KeyEvent.VK_DOWN){
			if (mMode == NAV_MODE){
				ChangeBinSize(numDaysInBin+1,true);
				consumed = true;	
			}
		}
		if (key == KeyEvent.VK_LEFT){

			if (isCtrlClicked){

				//mBinInfoHotSpot.x += binWidth;
				if (mDrawnBinInfoInterval >= 0){
					mDrawnBinInfoInterval -= numDaysInBin;
				}
				DrawBinInfo(null,mDrawnBinInfoInterval,-1,true,true);
			}
			else{
				mDaysShift += numDaysInBin;
				ForceRepaint(false);
			}

			consumed = true;

			/*			
			mBinInfoHotSpot.x -= binWidth;
			DrawBinInfo(mBinInfoHotSpot);
			*/			
			/*
			if (barHeight >= 5.0){
				barHeight -= 1.0;	
				consumed = true;
				ForceRepaint();
			}
			 */

				}
		else if (key == KeyEvent.VK_RIGHT){


			if (isCtrlClicked){
				//mBinInfoHotSpot.x += binWidth;
				if (mDrawnBinInfoInterval >= 0){
					mDrawnBinInfoInterval += numDaysInBin;
				}
				DrawBinInfo(null,mDrawnBinInfoInterval,-1,true,true);
			}
			else{
				mDaysShift -= numDaysInBin;
				ForceRepaint(false);
			}
			consumed = true;
		
			/*
			mBinInfoHotSpot.x += binWidth;
			DrawBinInfo(mBinInfoHotSpot);
			*/
			/*
			barHeight += 1.0;	
			consumed = true;	
			ForceRepaint();
			*/
				}
	
		/*
		else if (key == KeyEvent.VK_1){
			showMonthTicks = !showMonthTicks;
			consumed = true;	
			ForceRepaint();
		}
		
		else if (key == KeyEvent.VK_2){
			showSecondSeries = !showSecondSeries;
			
			if (!showSecondSeries){
				barHeight = maxBarHeight;
			}
			consumed = true;	
			ForceRepaint();
		}
		else if (key == KeyEvent.VK_3){
			showBinSize = !showBinSize;
			consumed = true;	
			ForceRepaint();
		}

		else if (key == KeyEvent.VK_S){
			superimpose = !superimpose;
			if (superimpose){
				barHeight = maxBarHeight;
			}
			consumed = true;	
			ForceRepaint();
		}
		else if (key == KeyEvent.VK_D){
			showStdDev = !showStdDev;
			consumed = true;	
			ForceRepaint();
		}
		else if (key == KeyEvent.VK_M){
			showMaxMin = !showMaxMin;
			consumed = true;	
			ForceRepaint();
		}
		else if (key == KeyEvent.VK_F1){
			showFullToolTip = !showFullToolTip;
			consumed = true;	
			ForceRepaint();
		}
		
		else if (key == KeyEvent.VK_C){
			showConnectingLines = !showConnectingLines;
			consumed = true;	
			ForceRepaint();
		}
		*/
		
		if (consumed)
			e.consume();
	
	}
	
	public void keyReleased( KeyEvent e ) {}
	public void keyTyped( KeyEvent e ) {}
	
	private int GetBinIndexFromPoint(Point p)
	{
		int binIndex = -1;
		// check for the vertical positioning
		int t = topChartY + 5;
		int y = topChartY + 5;
		if (p.y >= y -(int)maxBarHeight && p.y <= y){
			binIndex = (p.x-mLeftX) / binWidth;
		}
		else if (p.y > y && p.y <= yLabels+10){

			double ratio = (double)(yLabels-p.y) / (double)(yLabels-y);

			int i = 0;
			int totalNumOfDays = mDataSet.GetNumIntervals();
			int expectedWidth = numBins * binWidth;
			double factor,temp;
			int leftInterval 	= ((BinMarker)(this.mBinMarkerVec1.elementAt(0))).mBinData.mStartIntervalIndex; 
			int rightInterval 	= ((BinMarker)(this.mBinMarkerVec1.elementAt(mBinMarkerVec1.size()-1))).mBinData.mEndIntervalIndex;
			
			i = leftInterval;
			factor = (i/(double)totalNumOfDays);	
			temp = (double)i/(double)numDaysInBin*binWidth;
			/*
			int centerX = (int)mDisplayRegion.getCenterX();
			int leftX = (int)temp + (int)mDisplayRegion.getCenterX()-expectedWidth/2 + mShiftX;
			*/

			xLabels = (int)(factor*(mDisplayRegion.width-80)+mDisplayRegion.getMinX()+40);
			int leftX = (int)((1-ratio) * xLabels + ratio*mLeftX);
			
			i = rightInterval;
			factor = (i/(double)totalNumOfDays);
			/*	
			temp = (double)i/(double)numDaysInBin*binWidth;
			int rightX = (int)temp + (int)mDisplayRegion.getCenterX()-expectedWidth/2 + mShiftX;
			*/
			xLabels = (int)(factor*(mDisplayRegion.width-80)+mDisplayRegion.getMinX()+40);
			int rightX = (int)((1-ratio) * xLabels + ratio*mRightX);

			factor = (mDisplayRegion.width-80)/ (double)(numBins);
			
			double auxBinWidth = (1-ratio) * factor + ratio * binWidth;
			binIndex = (int)((p.x-leftX) / auxBinWidth);
		}
		
		return binIndex;
	}
	
	private BinData GetBinDataFromBinIndex(int index)
	{
		BinData ret = null;
		
		if (index >= 0 && index < mBinMarkerVec1.size() ){
			BinMarker marker = (BinMarker)(mBinMarkerVec1.elementAt(index));
			ret = marker.mBinData;
		}
		
		return ret;
		
	}
	
	private BinData GetBinDataFromPoint(Point p,boolean checkVerticalProximity)
	{
		int binIndex = GetBinIndexFromPoint(p);
		BinData ret = null;
		
		if (binIndex >= 0 && mBinMarkerVec1 != null && binIndex < mBinMarkerVec1.size()){

			// Check the vertical placement of the mouse
			BinMarker marker = (BinMarker)(mBinMarkerVec1.elementAt(binIndex));
			
			if (checkVerticalProximity){
				if (marker.mBounds.contains(p)){
					ret = marker.mBinData;
				}
				else
					ret = null;
			}
			else{
				ret = marker.mBinData;	
			}
		}
		
		return ret;		
	}
	
	public String getToolTipText(java.awt.event.MouseEvent event) 	
	{
		Point p = event.getPoint();
		BinData binData = null;//		GetBinDataFromPoint(p,true);

		String msg = null;
		if (binData != null){
	
			msg = "";
			
			SimpleDateFormat formatter = new SimpleDateFormat("dd.mm.yy");
			msg += formatter.format(mDataSet.GetDateByIntervalIndex(binData.mStartIntervalIndex));
			msg += "-";
			msg += formatter.format(mDataSet.GetDateByIntervalIndex(binData.mEndIntervalIndex));
			msg += "\n";
			
			if (showFullToolTip){
				NumberFormat numFormat = NumberFormat.getInstance();
				numFormat.setMinimumFractionDigits( 3 );
				numFormat.setMaximumFractionDigits( 3 );
				msg += numFormat.format( binData.mBinValue );
	
				msg += "\nMax:" + numFormat.format( binData.mMaxValue);
				msg += "\nMin:" + numFormat.format( binData.mMinValue);
				msg += "\nSD:" + numFormat.format( binData.mStdDev);
	
			}
		}
		
		if (mTimeScaleControlBounds != null && mTimeScaleControlBounds.contains(p)){
			msg = "Change Time Scale";
		}
		else if (mBinSizeControlBounds != null && mBinSizeControlBounds.contains(p)){
			msg = "Change Bin Size";
		}
		

		return msg;	
	}

	private int GetYearLabelUnderMouse(Point p)
	{
		int ret = -1;
		for (int i=0;i<mYearLabelTriggers.size();i++){
			Rectangle rect= (Rectangle)mYearLabelTriggers.elementAt(i);
			if (rect.contains(p)){
				ret = i;
				break;
			}
		}
		
		return ret;
	}

	protected void HandleMousePressed(MouseEvent e)
	{
		// get the clicked on bin
		//System.out.println("TRapez - mouse click");	
		boolean isRightClick 	= ((e.getModifiers() & MouseEvent.BUTTON3_MASK) != 0);
		boolean isShiftPressed 	= ((e.getModifiers() & InputEvent.SHIFT_MASK) != 0);
		boolean isAltPressed	= ((e.getModifiers() & InputEvent.ALT_MASK) != 0);
		
		Point p = e.getPoint();
		
		int y = topChartY + 5;

		
		if (isRightClick && p.y < 20){
			JPopupMenu menu = CreatePopupMenu();
			int width = menu.getWidth();
			
			int xLoc = e.getX();
			Dimension d = getSize();
			if (xLoc + width > d.width){
				xLoc = d.width - width;
			}
			
			menu.show(this,
			xLoc, e.getY());
			return;
		}

	
		// check if the mouse is in one of the year labels
		int yearLabel = GetYearLabelUnderMouse(e.getPoint());
		if (!isRightClick && yearLabel >= 0){
			System.out.println(yearLabel);
			
			// center year in the display

			int i = 365 * yearLabel + 365/2;

			double temp = (double)i/(double)numDaysInBin*binWidth;
			int centerX = (int)mDisplayRegion.getCenterX();
			int expectedWidth = numBins * binWidth;
			mShiftX =  centerX - ((int)temp + (int)mDisplayRegion.getCenterX()-expectedWidth/2);
			mShiftX = mShiftX / binWidth;
			int newDaysShift = mShiftX * numDaysInBin;
			ChangeDaysShiftAnim(newDaysShift);
		}
		else if (isRightClick){
			HandleMouseDragged(e);
		}
		else if (!isRightClick && mMode == NAV_MODE && mBinSizeControlBounds != null && mBinSizeControlBounds.contains(p)){
			mStartDragMousePos = p;
			mBinSizeControlDragMode = true;
		}
		else if (!isRightClick && mMode == NAV_MODE && mTimeScaleControlBounds != null && mTimeScaleControlBounds.contains(p)){
			mStartDragMousePos = p;
			mTimeScaleControlDragMode = true;
		}
		else if (!isRightClick && mMode == NAV_MODE && p.y >= y -(int)maxBarHeight && p.y <= y){
			int binIndex = -1;
			binIndex = GetBinIndexFromPoint(e.getPoint());
			
			// get the center interval for that bin
			if (binIndex >= 0 && binIndex < mBinMarkerVec1.size()){
				BinMarker marker = (BinMarker)mBinMarkerVec1.elementAt(binIndex);
				int startIntervalIndex = marker.mBinData.mStartIntervalIndex;
				int endIntervalIndex = marker.mBinData.mEndIntervalIndex;
				int intervalInFocus = (startIntervalIndex + endIntervalIndex)/2;		

				double temp = (double)intervalInFocus/(double)numDaysInBin*binWidth;
				int centerX = (int)mDisplayRegion.getCenterX();
				int expectedWidth = numBins * binWidth;
				mShiftX =  centerX - ((int)temp + (int)mDisplayRegion.getCenterX()-expectedWidth/2);
				mShiftX = mShiftX / binWidth;
				int newDaysShift = mShiftX * numDaysInBin;
				ChangeDaysShiftAnim(newDaysShift);
			}
		}
		else if (!isRightClick && mMode == MARK_MODE && p.y >= y -(int)maxBarHeight && p.y <= y){
			
			int binIndex = -1;
			binIndex = GetBinIndexFromPoint(e.getPoint());
			
			if (binIndex >= 0 && binIndex < mBinMarkerVec1.size()){

				BinMarker marker = (BinMarker)mBinMarkerVec1.elementAt(binIndex);

				int startIntervalIndex 	= -1;
				int endIntervalIndex	= -1;

				// do we have a previous click somewhere
				if (isShiftPressed && mLastMarkBinIndex >= 0){

					BinMarker prev_marker = (BinMarker)mBinMarkerVec1.elementAt(mLastMarkBinIndex);
					
					if (mLastMarkBinIndex <= binIndex){
						startIntervalIndex = prev_marker.mBinData.mStartIntervalIndex;
						endIntervalIndex = marker.mBinData.mEndIntervalIndex;
					}
					else{
						startIntervalIndex = marker.mBinData.mStartIntervalIndex;
						endIntervalIndex = prev_marker.mBinData.mEndIntervalIndex;
					}
					mLastMarkBinIndex = -1;
				}
				else{
					startIntervalIndex = marker.mBinData.mStartIntervalIndex;
					endIntervalIndex = 	marker.mBinData.mEndIntervalIndex;			
					mLastMarkBinIndex = binIndex;
				}
				for (int k=startIntervalIndex;k<=endIntervalIndex;k++){
					mIntervalSelectionVec[k] = isAltPressed ? false : true;
				}
				
				DoRepaint(true);
	
			}
		}
	}
	
	protected  void HandleMouseDragged(MouseEvent e)
	{
		mMousePos = e.getPoint();
		Point p = e.getPoint();
		
		boolean isRightClick = ((e.getModifiers() & MouseEvent.BUTTON3_MASK) != 0);
		boolean isCtrlClicked = false;

		if((e.getModifiers() & InputEvent.CTRL_MASK) != 0){ 
			isCtrlClicked = true;
		}
		
		if (isRightClick){
			DrawBinInfo(p,-1,-1,true,true);
		}
		else if (mMode == NAV_MODE && !isRightClick && mBinSizeControlDragMode){
			
			int diffX = p.x - mDisplayRegion.x;
			if (diffX < 0){
				diffX = 0;
			}
			
			if (diffX > mDisplayRegion.width){
				diffX = mDisplayRegion.width;
			}
			
			ChangeBinSize(diffX+1,true);
		}
		else if (mMode == NAV_MODE && !isRightClick && mTimeScaleControlDragMode){
			
			int diffX = p.x - mDisplayRegion.x;
			if (diffX < 0){
				diffX = 0;
			}
			
			if (diffX > 20){
				diffX = 20;
			}
			
			binWidth = diffX+3;
			ForceRepaint(false);
		}

		else if (false && mMode == MARK_MODE){
			int binIndex = -1;
			binIndex = GetBinIndexFromPoint(e.getPoint());
		
			if (binIndex >= 0){
				BinMarker marker = (BinMarker)mBinMarkerVec1.elementAt(binIndex);
			
				for (int k=marker.mBinData.mStartIntervalIndex;k<=marker.mBinData.mEndIntervalIndex;k++){
					mIntervalSelectionVec[k] = true;
				}

				ForceRepaint(false);
	
/*
				Graphics2D g2 = (Graphics2D)(getGraphics());
				DrawBinHighlight(g2);
*/			}
		}
	}

	protected void HandleMouseReleased(MouseEvent e)
	{
		mBinSizeControlDragMode = false;
		mTimeScaleControlDragMode = false;
	}
	
	protected void HandleMouseMoved(MouseEvent e)
	{
/*
		mMousePos = e.getPoint();
		
		boolean isRightClick = ((e.getModifiers() & MouseEvent.BUTTON3_MASK) != 0);
		System.out.println("isRightClick "+isRightClick);
		boolean isCtrlClicked = false;
		if((e.getModifiers() & InputEvent.CTRL_MASK) != 0){ 
			isCtrlClicked = true;
		}
		
		if (isRightClick){
			Point p = e.getPoint();
			DrawBinInfo(p);		
		}
*/
	}
	
	
	protected void DrawBinHighlightBoxes(Graphics2D g2,int series)
	{
		int x,y,tempY;
		int maxY = -1,minY = -1;
		int startX = 0;
		int endX = 0;
		boolean inStreak = false;
		
		Vector binVec = null;
		ArrayList binDataArray = null;
		
		if (series == 0){
			binVec = mBinMarkerVec1;
			binDataArray = binValues1;
		}
		else{
			binVec = mBinMarkerVec2;
			binDataArray = binValues2;
		}
		
		for (int i=0;i < binVec.size(); i++){
				
			g2.setColor(mCurrencyColor[series]);
			BinMarker marker = (BinMarker)(binVec.elementAt(i));
			BinData binVals = marker.mBinData;
			
			// should we highlight the bin ?
			boolean highlightBin = ShouldHighlightBin(binVals);

			x = marker.mXCoord;
			y = marker.mYCoord;
			tempY = y;

			if (!inStreak && highlightBin){
				inStreak = true;
				startX = x;
				endX = x;
				maxY = minY = tempY;					
			}
				
			if (inStreak && highlightBin){
				if (tempY < minY)	
					minY = tempY;
						
				if (tempY > maxY)
					maxY = tempY;
			}

			if (inStreak && i == 0){
					
				// scan for the beginning of the marked period
				int k=marker.mBinIndex;

				double auxY;
				while(k >= 0){
					BinData auxBinVals = (BinData)(binDataArray.get(k));
					if (ShouldHighlightBin(auxBinVals)){
						double val = auxBinVals.mNormalizedValue;
						val *= barHeight;
						
						auxY = topChartY - val;
						
						if (series != 0){
							if (!superimpose){
								auxY = auxY - (int)(barHeight);
							}
						}

						if (auxY < minY)	
							minY = (int)auxY;
						
						if (auxY > maxY)
							maxY = (int)auxY;
					}
					else{
						break;
					}
						
					k--;
				}
			}
			else if (inStreak && i == binVec.size()-1){
				// scan for the end of the marked period
				int k=marker.mBinIndex;

				double auxY = 0.0;
				while(k < binDataArray.size()){
					BinData auxBinVals = (BinData)(binDataArray.get(k));
					if (ShouldHighlightBin(auxBinVals)){
						double val = auxBinVals.mNormalizedValue;
						val *= barHeight;

						auxY = topChartY - val;
						
						if (series != 0){
							if (!superimpose){
								auxY = auxY - (int)(barHeight);
							}
						}

						if (auxY < minY)	
							minY = (int)auxY;
						
						if (auxY > maxY)
							maxY = (int)auxY;
					}
					else{
						break;
					}
						
					k++;
					endX = x;
				}
				
				highlightBin = false;
			}
				
			if (inStreak && !highlightBin){
				inStreak = false;
				//endX = x;

				// draw the box
				minY -= 5;
				maxY += 5;
				startX -= binWidth/2;
				endX += binWidth/2;					
				g2.fillRect(startX,minY,endX-startX,maxY-minY);
			}
			
			endX = x;
				
		}		
	}
	
	protected void DrawBinHighlight(Graphics2D g2)
	{
		if (!showMarkup)
			return;
			
		AlphaComposite ac =
				   AlphaComposite.getInstance(AlphaComposite.SRC_OVER,0.2f);
	
		Composite oldComp = g2.getComposite();
	    g2.setComposite(ac);

		boolean plainMode = false;

		if (plainMode){
			int x,y;
			for (int i=0;i < mBinMarkerVec1.size(); i++){
				
				g2.setColor(mCurrencyColor[0]);
				BinMarker marker = (BinMarker)(mBinMarkerVec1.elementAt(i));
				BinData binVals = marker.mBinData;
			
				// should we highlight the bin ?
		
				if (ShouldHighlightBin(binVals)){
					x = marker.mXCoord;
					y = marker.mYCoord;
					g2.fillRect(x-half_BinWidth,y-half_BinWidth-5,binWidth,(int)3+10);
				}
				
				// is the second series showing ?
				if (showSecondSeries){
					g2.setColor(mCurrencyColor[1]);
	
					marker = (BinMarker)(mBinMarkerVec2.elementAt(i));
					binVals = marker.mBinData;
			
					// should we highlight the bin ?
		
					if (ShouldHighlightBin(binVals)){
						x = marker.mXCoord;
						y = marker.mYCoord;
						g2.fillRect(x-half_BinWidth,y-half_BinWidth-5,binWidth,(int)3+10);
					}
				}
				
			}
		}
		else{
			DrawBinHighlightBoxes(g2,0);
			DrawBinHighlightBoxes(g2,1);
		}			

		g2.setComposite(oldComp);

	}
	

	protected double GetYCoord(int currencyIndex,double normalizedVal){
		
		double auxY = 0.0;
		double val = normalizedVal * barHeight;

		auxY = topChartY - val;
						
		if (currencyIndex != 0){
			if (!superimpose){
				auxY = auxY - (int)(barHeight);
			}
		}
		
		return auxY;
	}

	protected void DrawYAxis(Graphics2D g)
	{
		if (!drawYAxis)
			return;
			
		int y;

		g.setColor(mCurrencyColor[0]);
		
		int numTicks = 10;
		
		for (int i=0; i< numTicks; i++){
			y = (int)GetYCoord(0,(double)(i)/(double)(numTicks));	
			g.drawLine(mRightX+10,y,mRightX+15,y);
		}
	}
	
	protected int GetBinIndexFromInterval(int inInterval)
	{
		int ret = -1;
		for (int i=0;i<mBinMarkerVec1.size();i++){
			int leftInterval 	= ((BinMarker)(this.mBinMarkerVec1.elementAt(i))).mBinData.mStartIntervalIndex; 
			int rightInterval 	= ((BinMarker)(this.mBinMarkerVec1.elementAt(i))).mBinData.mEndIntervalIndex;
		
			if (inInterval >= leftInterval && inInterval <= rightInterval){
				ret = i;
				break;	
			}
		}
		
		return ret;
	}
	
	protected void SyncBinInfoDraw(int intervalInFocus,
								   boolean scrollToMakeVisible,
								   int focusPeriodLength)
	{
		mDrawnBinInfoInterval = intervalInFocus;

		// should we scroll
		if (scrollToMakeVisible && mBinMarkerVec1 != null){
			// get the first interval show
			
			BinMarker firstMarker = (BinMarker)mBinMarkerVec1.elementAt(0);
			BinMarker lastMarker = (BinMarker)mBinMarkerVec1.elementAt(mBinMarkerVec1.size()-1);
			int leftVisibleInterval = firstMarker.mBinData.mStartIntervalIndex;
			int rightVisibleInterval = lastMarker.mBinData.mEndIntervalIndex;
			
			if (intervalInFocus < leftVisibleInterval){
				ChangeDaysShift(mDaysShift + (leftVisibleInterval-intervalInFocus+numDaysInBin),false);
			}
			else if (intervalInFocus > rightVisibleInterval){
				ChangeDaysShift(mDaysShift - (intervalInFocus-rightVisibleInterval+numDaysInBin),false);
			}
			else{
				// no need to scroll
				DrawBinInfo(null,mDrawnBinInfoInterval,focusPeriodLength,true,false);
			}
		}
		

	}
	
	protected void DrawBinInfo(Point hotSpot,
							   int inIntervalInFocus,
							  int focusPeriodLength, // -1 for default
							   boolean doBlit,
							   boolean doNotify)
	{
		// figure out which bin is it and then display a line 
		Point p = hotSpot;
		BinData binData = null;
		int binIndex = -1;
		int auxY = 20;
		int fullInfoX = 2;
	
		if (inIntervalInFocus < 0){
			if (p != null){
				binData = GetBinDataFromPoint(p,false);
				binIndex = GetBinIndexFromPoint(p);
			}

		}
		else{
			binIndex = 	GetBinIndexFromInterval(inIntervalInFocus);
			binData = GetBinDataFromBinIndex(binIndex);
		}
		
		/*
		if (mLastDrawnInfoBinIndex == binIndex)
			return;
		*/
		String msg = null;
		Dimension d = getSize();
		
		if (binData != null && bimg[0] != null){
			
			mBinInfoHotSpot = p;
			
			BinMarker marker = (BinMarker)(mBinMarkerVec1.elementAt(binIndex));

			// draw markers for the binValues
			//Graphics2D g = (Graphics2D) this.getGraphics();
		
			Graphics2D g = createGraphics2D(1,d.width, d.height);
			
			// draw the graph without info 
			g.drawImage(bimg[0], 0, 0, this);
			
			// add info
			g.setColor(mCurrencyColor[0]);
			g.drawLine(mRightX,marker.mYCoord,mRightX+mTickLabelShift,marker.mYCoord);
			String binValueStr;

			Font smallFont = new Font("Serif",Font.PLAIN,9);
			Font saveFont = g.getFont();
			g.setFont(smallFont);

			
			NumberFormat numFormat = NumberFormat.getInstance();
			numFormat.setMinimumFractionDigits( 3 );
			numFormat.setMaximumFractionDigits( 3 );
			if (marker.mNoDataAvailabe){
				binValueStr = "n/a";
			}
			else{
				binValueStr = numFormat.format( binData.mBinValue );
			}

			int strHeight = 0;

			FontMetrics auxFM   = g.getFontMetrics();  // metrics for this object
			//Rectangle2D auxRect = auxFM.getStringBounds(binValueStr, g); // size of string
			//strHeight = (int)auxRect.getHeight();
			strHeight = 9; //auxFM.getHeight();
			int strYPos = marker.mYCoord + strHeight/2;
			g.drawString(binValueStr,mRightX+mTickLabelShift,strYPos);
			
			if (drawFullBinInfo){
				// format the information:
				
				String infoStr = "";
				numFormat.setMinimumFractionDigits( 3 );
				numFormat.setMaximumFractionDigits( 3 );
				
				g.drawString("Max:",fullInfoX,auxY);
				auxY += auxFM.getHeight();
				
				infoStr = numFormat.format( binData.mRawMaxValue);
				g.drawString(infoStr,fullInfoX,auxY);
				auxY += auxFM.getHeight();
				
				g.drawString("Min:",fullInfoX,auxY);
				auxY += auxFM.getHeight();
				
				infoStr = numFormat.format( binData.mRawMinValue);
				g.drawString(infoStr,fullInfoX,auxY);
				auxY += auxFM.getHeight();
				
				g.drawString("SD:",fullInfoX+2,auxY);
				auxY += auxFM.getHeight();
				
				infoStr = numFormat.format( binData.mRawStdDev);
				g.drawString(infoStr,fullInfoX,auxY);
				auxY += auxFM.getLeading();
			}

			if (showSecondSeries){
				
				BinMarker marker2 = (BinMarker)(mBinMarkerVec2.elementAt(binIndex));
				g.setColor(mCurrencyColor[1]);

				int string2YPos = marker2.mYCoord + strHeight/2;				
				if (Math.abs(string2YPos - strYPos) < strHeight){
					if (string2YPos < strYPos)
						string2YPos = strYPos - strHeight;
					else
						string2YPos = strYPos + strHeight;
				}
				
				g.drawLine(mRightX,marker2.mYCoord,mRightX+mTickLabelShift,marker2.mYCoord);

				if (marker2.mNoDataAvailabe){
					binValueStr = "n/a";
				}
				else{
					binValueStr = numFormat.format( marker2.mBinData.mBinValue );
				}

				g.drawString(binValueStr,mRightX+mTickLabelShift,string2YPos);
				binData = marker2.mBinData;
				if (drawFullBinInfo){
					// format the information:
				
					auxY += 3*auxFM.getHeight();
				
					String infoStr = "";
					numFormat.setMinimumFractionDigits( 3 );
					numFormat.setMaximumFractionDigits( 3 );
				
					g.drawString("Max:",fullInfoX,auxY);
					auxY += auxFM.getHeight();
				
					infoStr = numFormat.format( binData.mRawMaxValue);
					g.drawString(infoStr,fullInfoX,auxY);
					auxY += auxFM.getHeight();
				
					g.drawString("Min:",fullInfoX,auxY);
					auxY += auxFM.getHeight();
				
					infoStr = numFormat.format( binData.mRawMinValue);
					g.drawString(infoStr,fullInfoX,auxY);
					auxY += auxFM.getHeight();
				
					g.drawString("SD:",fullInfoX,auxY);
					auxY += auxFM.getHeight();
				
					infoStr = numFormat.format( binData.mRawStdDev);
					g.drawString(infoStr,fullInfoX,auxY);
					auxY += auxFM.getLeading();
				}
				
			}
			
			g.setFont(saveFont);

			int totalNumOfDays = mDataSet.GetNumIntervals();
			int tickLeap = 365;

			// draw the image again

			int y = topChartY + 5;

			
			// draw a line over it
			Color markerColor = new Color(191,223,255);

			g.setColor(markerColor);
			g.drawLine(marker.mXCoord,y,marker.mXCoord,y-(int)maxBarHeight);	
			if (focusPeriodLength >= 0){
				int numBinsInPeriod = focusPeriodLength/numDaysInBin-1;
				if (numBinsInPeriod > 1){
					int width = numBinsInPeriod*binWidth;
					if (marker.mXCoord + width > mDisplayRegion.getMaxX()){
						width = (int)(mDisplayRegion.getMaxX() - marker.mXCoord);
					}

					AlphaComposite ac =
							   AlphaComposite.getInstance(AlphaComposite.SRC_OVER,0.2f);
	
					Composite oldComp = g.getComposite();
					g.setComposite(ac);
					g.fillRect(marker.mXCoord,y-(int)maxBarHeight,width,(int)maxBarHeight);	
					g.setComposite(oldComp);

				}
			}
			
			double factor1= ((double)binData.mStartIntervalIndex / (double)totalNumOfDays);
			double factor2= ((double)binData.mEndIntervalIndex / (double)totalNumOfDays);

			int x1 = (int)(factor1*((int)mDisplayRegion.width-80)+(int)mDisplayRegion.getMinX()+40);
			int x2 = (int)(factor2*((int)mDisplayRegion.width-80)+(int)mDisplayRegion.getMinX()+40);
			
			g.setColor(markerColor);
			g.drawLine(marker.mXCoord,y,x1,yLabels);
			
			// set transparency
			
			AlphaComposite ac =
					   AlphaComposite.getInstance(AlphaComposite.SRC_OVER,0.5f);
	
			Composite oldComp = g.getComposite();
			g.setComposite(ac);
			
			Polygon poly = new Polygon();
			poly.addPoint(marker.mXCoord,y);
			poly.addPoint(x1,yLabels);

			poly.addPoint(x1,yLabels+10);
			poly.addPoint(x2,yLabels+10);

			poly.addPoint(x2,yLabels);
			

			g.fillPolygon(poly);
			
			// reset transparency
			g.setComposite(oldComp);
			
			
			
			
			// add the period information at the bottom
			
			String binDesc = "";
			
			SimpleDateFormat formatter = new SimpleDateFormat("dd.mm.yy");
			binDesc += formatter.format(mDataSet.GetDateByIntervalIndex(binData.mStartIntervalIndex));
			binDesc += "-";
			binDesc += formatter.format(mDataSet.GetDateByIntervalIndex(binData.mEndIntervalIndex));

			Font f = g.getFont();

			// Find the size of this text so we can center it
			FontMetrics fm   = g.getFontMetrics(f);  // metrics for this object
			Rectangle2D rect = fm.getStringBounds(binDesc, g); // size of string
			 
			int width = (int)rect.getWidth();
			int height = (int)rect.getHeight();

			int labelLeftX 	= (x1+x2-width)/2-2;
			int labelRightX = labelLeftX + width + 2;

			if (labelLeftX < mDisplayRegion.getMinX()){
				labelLeftX = (int)mDisplayRegion.getMinX();
			}
			
			if (labelRightX > mDisplayRegion.getMaxX()){
				labelLeftX -= (labelRightX - mDisplayRegion.getMaxX());				
			}

			g.setColor(Color.yellow);
			//g.setColor(lightBlue);
			g.fillRect(labelLeftX-2,yLabels+40-height-2,width+2,height+8);
			g.setColor(Color.black);
			g.drawRect(labelLeftX-2,yLabels+40-height-2,width+2,height+8);
			g.drawString(binDesc,labelLeftX,yLabels+40);
		
			mLastDrawnInfoBinIndex = binIndex;
			
			if (inIntervalInFocus < 0){
				//mDrawnBinInfoInterval = (binData.mStartIntervalIndex + binData.mEndIntervalIndex)/2;
				mDrawnBinInfoInterval = binData.mStartIntervalIndex;
			}
		
			g.dispose();
		}
		else{
			Graphics2D g = createGraphics2D(1,d.width, d.height);
			// draw the graph without info 
			g.drawImage(bimg[0], 0, 0, this);
			if (p != null){
				mDrawnBinInfoInterval = -1;
			}
		}
		
		if (doBlit){
			BlitBufferedImage();
		}
		
		if (doNotify && mDrawnBinInfoInterval >= 0){
			mVizPanelMgr.NotifyOnBinInfoChange(this,mDrawnBinInfoInterval,numDaysInBin);
		}
		
	}
	
	private void DrawBinSizeMarker(Graphics2D g)
	{
		mBinSizeControlBounds = new Polygon();
		
		int width = 10;
		mBinSizeControlBounds.addPoint(0,0);
		mBinSizeControlBounds.addPoint(width,0);
		mBinSizeControlBounds.addPoint(width/2,8);

		mBinSizeControlBounds.translate(mDisplayRegion.x + numDaysInBin - (width/2) ,0);
		
		g.setColor(Color.darkGray);
		g.fillPolygon(mBinSizeControlBounds);
		
		g.setColor(Color.gray);
		g.drawPolygon(mBinSizeControlBounds);
		
		if (showBinSize || showNumBins){
			
			Font smallFont = new Font("Serif",Font.PLAIN,10);
			Font saveFont = g.getFont();
			g.setFont(smallFont);
			g.setColor(Color.gray);

			String binInfo = "";
			Rectangle rect = mBinSizeControlBounds.getBoundingBox();

			if (showBinSize){	
				binInfo += Integer.toString(numDaysInBin);
				if (showNumBins){
					binInfo += " / ";
				}
			}

			if (showNumBins){
				binInfo += "#" + numBins;
			}

			g.drawString(binInfo, (int)rect.getMaxX()+width+2, (int)rect.getMaxY()+2);
			g.setFont(saveFont);

		}
		
		
		
	}
	
	private void DrawTimeScaleMarker(Graphics2D g)
	{
		mTimeScaleControlBounds = new Polygon();
		
		int width = 10;
		mTimeScaleControlBounds.addPoint(0,0);
		mTimeScaleControlBounds.addPoint(width,0);
		mTimeScaleControlBounds.addPoint(width/2,-8);

		mTimeScaleControlBounds.translate(mDisplayRegion.x + binWidth - drawBinWidth - (width/2) ,(int)mDisplayRegion.getMaxY());
		
		g.setColor(Color.darkGray);
		g.fillPolygon(mTimeScaleControlBounds);
		
		g.setColor(Color.gray);
		g.drawPolygon(mTimeScaleControlBounds);
		
		if (false && showBinSize){
			g.setColor(Color.gray);
			
			Rectangle rect = mTimeScaleControlBounds.getBoundingBox();			
			g.drawString(Integer.toString(numDaysInBin), (int)rect.getMaxX()+width+2, (int)rect.getMaxY()+2);
		}
		
		
	}	

	public void CurrencySelectionChanged(int inSeries,String inCurrency)
	{
		mCurrency[inSeries-1] = inCurrency;
		ForceRepaint(true);
		this.paintAll(getGraphics());
	}
	
	public void ShowSecondCurrencyChanged(boolean newVal)
	{
		showSecondSeries = !showSecondSeries;
		if (!showSecondSeries){
			barHeight = maxBarHeight;
		}
		ForceRepaint(true);
	}

	public void OverlaySecondCurrencyChanged(boolean newVal)
	{
		superimpose = !superimpose;
		if (superimpose){
			barHeight = maxBarHeight;
		}
		ForceRepaint(true);
	}
	
	public  void DisplayStdDevChanged(boolean newVal)
	{
		showStdDev = newVal;
		ForceRepaint(false);
	}
		
	
	public void DisplayMinMaxChanged(boolean newVal)
	{
		showMaxMin = newVal;
		ForceRepaint(false);
	}
	

	public void Init()
	{
		SetDefaultDisplayRegion();
		this.setBackground(Color.white);
		ResetIntervalSelectionVec();
		mClusteringUtils.SetNumClusters(5);
	}

	public void SetDefaultDisplayRegion()
	{
		Dimension d = getSize();
		mDisplayRegion = new Rectangle(0,0,d.width,d.height-5);
		mDisplayRegion.width -= 45;
		mDisplayRegion.x = 5;
		AdjustDisplayRegionForValueTicks();
	}
	
	public void SetDisplayRegionForBinFullBinInfo()
	{

		Dimension d = getSize();
		mDisplayRegion = new Rectangle(0,0,d.width,d.height-5);
		mDisplayRegion.grow(-40,0);
		AdjustDisplayRegionForValueTicks();
	}
	
	public void AdjustDisplayRegionForValueTicks()
	{
		// compute the required width extesion
		if (bimg == null || mDisplayRegion == null)
			return;
			
		PaintBufferedImg();
	
		int shift = (mTickLabelShift-8);
		mDisplayRegion.width = mDisplayRegion.width - mTickLabelShift;
	}
	
	public void AdjustDisplayRegion()
	{
		if (drawFullBinInfo){
			SetDisplayRegionForBinFullBinInfo();
		}
		else{
			SetDefaultDisplayRegion();
		}
	}

	public Color GetColorForSeries(int seriesIndex)
	{
		return mCurrencyColor[seriesIndex];
	}
	
	public void SetColorForSeries(int seriesIndex,Color inColor)
	{
		mCurrencyColor[seriesIndex] = inColor;
		ForceRepaint(false);
	}
	
	public void ConnectLinesChanged(boolean newVal)
	{
		showConnectingLines = newVal;
		ForceRepaint(false);
	}
	
	public void ShowBinSize(boolean newVal)
	{
		showBinSize = newVal;
		ForceRepaint(false);
	}
	
	public void ShowMarksChanged(boolean newMode)
	{
		showMarkup = newMode;
		ForceRepaint(false);
	}
	
	public void MarkAll()
	{
		for (int i=0;i<mIntervalSelectionVec.length;i++){
			mIntervalSelectionVec[i] = true;		
		}
		
		ForceRepaint(false);
	}
	
	public void ClearAllMarks()
	{
		for (int i=0;i<mIntervalSelectionVec.length;i++){
			mIntervalSelectionVec[i] = false;		
		}
		
		ForceRepaint(false);		
	}
	
	public void ReverseMarks()
	{
		
		for (int i=0;i<mIntervalSelectionVec.length;i++){
			mIntervalSelectionVec[i] = !mIntervalSelectionVec[i];		
		}
		
		ForceRepaint(false);		
	}
	
	private boolean ShouldHighlightBin(BinData binVals)
	{
		
		boolean highlightBin = false;
		for (int k=binVals.mStartIntervalIndex;k<=binVals.mEndIntervalIndex;k++){
			if (mIntervalSelectionVec[k] == true){
				highlightBin = true;
			}
		}
		
		return highlightBin;
	}

	public void ChangeDaysShift(int daysShift,boolean doNotify)
	{
		mDaysShift = daysShift;
		PaintBufferedImg();
		BlitBufferedImage();
		if (doNotify){
			mVizPanelMgr.NotifyOnDaysShiftChange(this,daysShift);
		}
	}
	
	private void BlitBufferedImage()
	{
		Graphics2D g = (Graphics2D)getGraphics();
		g.drawImage(GetFinalBufferedImage(), 1, 1, this);
		g.dispose();
	}

	public void ChangeDaysShiftAnim(int newDaysShift)
	{
		int oldDaysShift = mDaysShift;
			
		long durationMilliSecs = 1000;
		boolean finish = false;
		double ratio = 0.0;
		long startTime = System.currentTimeMillis();
			
		while (!finish){
			ratio = (double)(System.currentTimeMillis()-startTime) / (double)durationMilliSecs;
			if (ratio >= 1.0){
				ratio = 1.0;
				finish = true;
			}
			
			int auxShift = (int)(ratio * (newDaysShift - oldDaysShift) + oldDaysShift);
			ChangeDaysShift(auxShift,true);	
		}
	}
	
	
	public void ChangeBinSize(int newBinSize,boolean doNotify)
	{
		numDaysInBin = newBinSize;
		DoRepaint(false);
		if (doNotify){
			mVizPanelMgr.NotifyOnUpdateBinSize(this,numDaysInBin);
		}
	}

	public void ChangeBinSizeAnim(int newNumDaysInBin)
	{
		int oldNumDays = numDaysInBin;
			
		long durationMilliSecs = 1000;
		boolean finish = false;
		double ratio = 0.0;
		long startTime = System.currentTimeMillis();
			
		while (!finish){
			ratio = (double)(System.currentTimeMillis()-startTime) / (double)durationMilliSecs;
			if (ratio >= 1.0){
				ratio = 1.0;
				finish = true;
			}
			
			int auxSize = (int)(ratio * (newNumDaysInBin - oldNumDays) + oldNumDays);

			ChangeBinSize(auxSize,false);
		}

			ChangeBinSize(numDaysInBin,true);
	}	
	
	public void DoRepaint(boolean doNotify)
	{
		Graphics2D g = (Graphics2D)getGraphics();
		PaintBufferedImg();
		g.drawImage(GetFinalBufferedImage(), 1, 1, this);
		g.dispose();
		
		if (doNotify){
			mVizPanelMgr.NotifyOnRepaint(this);
		}
	}
	
	public void ForceRepaint(boolean adjustDisplayRegion)
	{
		if (adjustDisplayRegion){
			AdjustDisplayRegion();
		}

		mForceRepaint = true;
		
		
		repaint();
	}
	
	public ArrayList GetBinValues(int currencyIndex,boolean onlySelection)
	{
		ArrayList ret = null;
		ret = ComputeBins(currencyIndex,numDaysInBin);
		
		if (onlySelection){
			ArrayList temp = new ArrayList();
			for (int i=0;i<ret.size();i++){
				
				BinData binVals = (BinData)(ret.get(i));
				
				if (ShouldHighlightBin(binVals)){
					temp.add(binVals);					
				}
			}
			
			ret = temp;
		}
		
		return ret;		
	}
	
	public ClusterAlgo GetClusterUtils()
	{
		return mClusteringUtils;
	}
	
	public int GetCurrencySeriesIndex(int currencyIndex)
	{
		// Convert from the currency ordinal index (0,1) 
		// to the actual index in the data set
		
		int seriesIndex = mDataSet.GetSeriesIndexByCode(mCurrency[currencyIndex]);
		return seriesIndex;
	}
	
	protected void DoClustering()
	{
		
		int seriesIndex = mDataSet.GetSeriesIndexByCode(mCurrency[0]);
		
		TimeSeries ts = mDataSet.GetSeriesByIndex(seriesIndex);
		ArrayList bins = ComputeBins(0,numDaysInBin);
		

		mClusteringUtils.Reset();
		mClusteringUtils.SetData(mDataSet,bins,ts);

		// Show clustering dialog and progress

		ClusterDialog dlg = new ClusterDialog(mOwnerFrame,mClusteringUtils);
		dlg.show();

		// mClusteringUtils.Process();

		if (!dlg.GetWasCancelled()){
			mClusteringUtils.ClassifyBins(bins);
			
			DoRepaint(false);
			mVizPanelMgr.NotifyOnClusteringStatusChange(this);
			mSetNumClustersMenu.setEnabled(true);
		}

	}
	
	protected void ChangeNumClusters(int newNum)
	{
		ArrayList bins = ComputeBins(0,numDaysInBin);
		mClusteringUtils.SetNumClusters(newNum);
		mClusteringUtils.ClassifyBins(bins);
		DoRepaint(false);
		mVizPanelMgr.NotifyOnClusteringStatusChange(this);
	}
	
	public void SetActive(boolean active)
	{
	   boolean needRefresh = (mIsActive != active);
	   mIsActive = active;

	   if (needRefresh){
	   		ForceRepaint(false);
	   }
	
	}

}
